package org.vraptor.config.xml;

import org.vraptor.config.UrlManagerConfig;

import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

/**
 * An url manager converter.
 * 
 * @author Guilherme Silveira
 * @since 2.3
 */
public class UrlManagerConverter implements Converter {

	/**
	 * Can it convert this class type?
	 */
	public boolean canConvert(Class clazz) {
		return clazz.equals(UrlManagerConfig.class);
	}

	/**
	 * Translates an object in the space to a xml string
	 */
	public void marshal(Object value, HierarchicalStreamWriter writer,
			MarshallingContext context) {
		UrlManagerConfig object = (UrlManagerConfig) value;
		writer.setValue(object.getTypeName());
	}

	/**
	 * Translates xml to an object.
	 */
	public Object unmarshal(HierarchicalStreamReader reader,
			UnmarshallingContext context) {
		return new UrlManagerConfig(reader.getValue());
	}

}
