package org.vraptor.interceptor;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.vraptor.Interceptor;
import org.vraptor.LogicException;
import org.vraptor.LogicFlow;
import org.vraptor.component.ComponentType;
import org.vraptor.reflection.JavaMethod;
import org.vraptor.scope.DefaultLogicRequest;
import org.vraptor.scope.LogicContext;
import org.vraptor.scope.RequestContext;
import org.vraptor.view.ViewException;

public class RegisterAttributesInteceptor implements Interceptor {

	@Deprecated
	public static final String LOGIC_METHOD_KEY = "org.vraptor.logic_method";

	private final JavaMethod method;

	private final ComponentType type;

	public RegisterAttributesInteceptor(JavaMethod method, ComponentType type) {
		this.method = method;
		this.type = type;
	}

	public void intercept(LogicFlow flow) throws LogicException, ViewException {
		DefaultLogicRequest req = (DefaultLogicRequest) flow.getLogicRequest();
		LogicContext logic = flow.getLogicRequest().getLogicContext();
		logic.setAttribute(LOGIC_METHOD_KEY, method.getMethod());

		RequestContext request = flow.getLogicRequest().getRequestContext();

		request.setAttribute(ComponentType.class.getName(), type);

		request.setAttribute("request", req.getRequest());
		request.setAttribute("httpServletRequest", req.getRequest());
		request.setAttribute(HttpSession.class.getName(), req.getRequest().getSession());

		request.setAttribute("response", req.getResponse());
		request.setAttribute("httpServletResponse", req.getResponse());
		request.setAttribute(HttpServletRequest.class.getName(), req.getRequest());

		request.setAttribute("application", req.getApplicationContext());
		request.setAttribute("servletContext", req.getApplicationContext());
		request.setAttribute(HttpServletResponse.class.getName(), req.getResponse());

		request.setAttribute("session", req.getRequest().getSession());
		request.setAttribute("httpSession", req.getRequest().getSession());
		request.setAttribute(ServletContext.class.getName(), req.getRequest().getSession().getServletContext());

		flow.execute();
	}
}
